Index: tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 541)
+++ tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 542)
@@ -75,20 +75,6 @@
  */
 public class Cooccurrence extends TXMResult  {
 
-	/** The a. */
-	static double[] a = new double[101];
-
-	/** The arbicoln. */
-	static double[][] arbicoln = new double[101][101];
-
-	/** The cof. */
-	static double[] cof = { 76.18009172947146, -86.50532032941677,
-		24.01409824083091, -1.231739572450155, 0.1208650973866179e-2,
-		-0.5395239384953e-5 };
-
-	/** The maxprec. */
-	static double maxprec = 0.0;
-
 	/** The nocooc. */
 	protected static int nocooc = 1;
 	/** The prefix r. */
@@ -173,14 +159,13 @@
 	/** The P. */
 	int P = -1;
 
+	String pCooccurentQueryFilter = "[]"; //$NON-NLS-1$
 	/** The mincof. */
 	private int pFCoocFilter;
 	/** The minf. */
 	private int pFminFilter;
 	/** The include xpivot. */
 	private boolean pIncludeXpivot;
-	/** The structural unit context limit. */
-	StructuralUnit pStructuralUnitLimit;
 	/** The maxleft. */
 	int pMaxLeftContextSize;
 	/** The maxright. */
@@ -196,7 +181,8 @@
 	/** The minscore. */
 	private double pScoreMinFilter;
 
-	String pCooccurentQueryFilter = "[]"; //$NON-NLS-1$
+	/** The structural unit context limit. */
+	StructuralUnit pStructuralUnitLimit;
 
 	/** The reference corpus to use = the R symbol that point to a matrix WordxFreqs. */
 	String referenceCorpus;
@@ -210,132 +196,87 @@
 	/** The writer. */
 	private BufferedWriter writer;
 
-	static {// void init_rbicoln()
-		int i, j;
-
-		for (i = 0; i < 101; i++)
-			for (j = 0; j < 101; j++)
-				arbicoln[i][j] = -1;
-	}
-
 	/**
-	 * Factln.
-	 *
-	 * @param n the n
-	 * @return the double
+	 * Creates an empty <link>Cooccurrence</link> object, child of the specified <link>Corpus</link>.
+	 * @param corpus
 	 */
-	static double factln(int n) {
-		if (n < 0)
-			System.err.println(CooccurrenceCoreMessages.Cooccurrence_102);
-		if (n <= 1)
-			return 0.0;
-		if (n <= 100)
-			return (a[n] > 0) ? a[n] : (a[n] = gammln(n + 1.0));
-			else
-				return gammln(n + 1.0);
+	public Cooccurrence(Corpus corpus) {
+		super(corpus);
 	}
 
 	/**
-	 * Gammln.
-	 *
-	 * @param xx the xx
-	 * @return the double
+	 * 
+	 * @param watcher
+	 * @param pQuery
+	 * @param pProperties
+	 * @param pStructuralUnitLimit
+	 * @param minleft
+	 * @param maxleft
+	 * @param minright
+	 * @param maxright
+	 * @param minf
+	 * @param minscore
+	 * @param mincof
+	 * @param pIncludeXpivot
+	 * @param buildLexicalTableWithCooccurrents
+	 * @return
 	 */
-	static double gammln(double xx) {
-		double x, y, tmp, ser;
+	protected boolean _compute(boolean update) {
+		//FIXME: debug
+		//System.out.println("cooc: "+corpus+" "+query+" "+properties+" "+limit+" "+maxLeft+" "+minLeft+" "+minRight+" "+maxRight+" "+minFreq+" "+minCof+" "+minScore+" "+includeXpivot);
 
-		int j;
+		monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_27);
+		try {
+			if (!this.stepQueryLimits()) {
+				return false;
+			}	
 
-		y = x = xx;
-		tmp = x + 5.5;
-		tmp -= (x + 0.5) * Math.log(tmp);
-		ser = 1.000000000190015;
-		for (j = 0; j <= 5; j++)
-			ser += cof[j] / ++y;
-		return -tmp + Math.log(2.5066282746310005 * ser / x);
-	}
+			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_28);
+			if (!this.stepGetMatches()) {
+				return false;
+			}
+			monitor.worked(10);
 
-	// Maths
-	/**
-	 * Proba binom.
-	 *
-	 * @param inf the inf
-	 * @param ing the ing
-	 * @param s the s
-	 * @param cf the cf
-	 * @return the double
-	 */
-	public static double ProbaBinom(long inf, long ing, long s, long cf) {
-		long mode = (long) Math.floor((double) ((inf + 1) * (ing + 1))
-				/ (inf + ing + s + 2));
-		long f, g, k;
-		double P = 0.0, p, lp, dnm;
-		int lpflag = 1;
+			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_29);
+			if (!this.stepBuildSignatures())
+				return false;
+			monitor.worked(10);
 
-		if (cf <= mode)
-			return (1.0);
+			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_30);
+			if (!this.stepCount())	{
+				return false;
+			}
+			monitor.worked(10);
 
-		if (inf < ing) {
-			f = inf;
-			g = ing;
-		} else {
-			f = ing;
-			g = inf;
-		}
-		;
+			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_31);
+			this.acquireSemaphore();
+			if (!this.stepBuildLexicalTable())	{
+				return false;
+			}
+			monitor.worked(10);
+			this.releaseSemaphore();
 
-		dnm = rbicoln((int) (f + g + s), (int) g);
-		for (k = cf; k <= f; k++) {
-			p = Math.exp(rbicoln((int) f, (int) k)
-					+ rbicoln((int) (s + g), (int) (g - k)) - dnm);
-			// if (lpflag > 0) { // rentre dedans de toute facon
-			lp = p;
-			lpflag = 0;
-			// };
-			if ((lp / p) < maxprec)
-				break;
-			lp = p;
-			P += p;
+			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_32);
+			this.acquireSemaphore();
+			if (!this.stepGetScores())	{
+				return false;
+			}
+			monitor.worked(10);
+			this.releaseSemaphore();
 		}
-		;
+		// user canceling
+		catch(ThreadDeath e) {
+			return false;
+		}
+		catch(Exception e) {
+			e.printStackTrace();
+			return false;
+		}
 
-		return (P);
-
-		/*
-		 * for (k = 0; k < cf; k++) { p = exp(rbicoln(f,
-		 * k)+rbicoln(s+g,g-k)-rbicoln(f+g+s, g)); P += p; }; return(fabs(1-P));
-		 */
-
+		return true;
 	}
 
 	/**
-	 * Rbicoln.
-	 *
-	 * @param n the n
-	 * @param k the k
-	 * @return the double
-	 */
-	static double rbicoln(int n, int k) {
-		if (n < 0)
-			System.err.println(CooccurrenceCoreMessages.Cooccurrence_103);
-		if (k < 0)
-			System.err.println(CooccurrenceCoreMessages.Cooccurrence_103);
-		if (n <= 100 && k <= 100)
-			return (arbicoln[n][k] >= 0) ? arbicoln[n][k]
-					: (arbicoln[n][k] = factln(n) - factln(k) - factln(n - k));
-			else
-				return factln(n) - factln(k) - factln(n - k);
-	}
-
-	/**
-	 * Creates an empty <link>Cooccurrence</link> object, child of the specified <link>Corpus</link>.
-	 * @param corpus
-	 */
-	public Cooccurrence(Corpus corpus) {
-		super(corpus, null);
-	}
-
-	/**
 	 * As r matrix.
 	 *
 	 * @return the string
@@ -380,18 +321,35 @@
 		return symbol;
 	}
 
-	/**
-	 * Calcmode.
-	 *
-	 * @param inf the inf
-	 * @param ing the ing
-	 * @param s the s
-	 * @param cf the cf
-	 * @return the long
-	 */
-	long calcmode(long inf, long ing, long s, long cf) {
-		return (long) Math.floor((double) ((inf + 1) * (ing + 1))
-				/ (inf + ing + s + 2));
+	@Override
+	public boolean canCompute() {
+
+		if (pQuery == null || pQuery.isEmpty()) {
+			System.out.println("No query set.");
+			return false;
+		}
+
+		if (pProperties == null) {
+			System.out.println("No properties set.");
+			return false;
+		}
+
+		if (getCorpus() == null) {
+			System.out.println("No corpus set.");
+			return false;
+		}
+
+		if (pQuery.getQueryString().length() == 0) {
+			System.out.println("Query is empty.");
+			return false;
+		}
+
+		if (pProperties.size() == 0) {
+			System.out.println("No properties filled.");
+			return false;
+		}
+
+		return true;
 	}
 
 	@Override
@@ -427,79 +385,6 @@
 	}
 
 	/**
-	 * 
-	 * @param watcher
-	 * @param pQuery
-	 * @param pProperties
-	 * @param pStructuralUnitLimit
-	 * @param minleft
-	 * @param maxleft
-	 * @param minright
-	 * @param maxright
-	 * @param minf
-	 * @param minscore
-	 * @param mincof
-	 * @param pIncludeXpivot
-	 * @param buildLexicalTableWithCooccurrents
-	 * @return
-	 */
-	protected boolean _compute(boolean update) {
-		this.monitor = monitor;
-		//FIXME: debug
-		//System.out.println("cooc: "+corpus+" "+query+" "+properties+" "+limit+" "+maxLeft+" "+minLeft+" "+minRight+" "+maxRight+" "+minFreq+" "+minCof+" "+minScore+" "+includeXpivot);
-
-		monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_27);
-		try {
-			if (!this.stepQueryLimits()) {
-				return false;
-			}	
-
-			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_28);
-			if (!this.stepGetMatches()) {
-				return false;
-			}
-			monitor.worked(10);
-
-			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_29);
-			if (!this.stepBuildSignatures())
-				return false;
-			monitor.worked(10);
-
-			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_30);
-			if (!this.stepCount())	{
-				return false;
-			}
-			monitor.worked(10);
-
-			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_31);
-			this.acquireSemaphore();
-			if (!this.stepBuildLexicalTable())	{
-				return false;
-			}
-			monitor.worked(10);
-			this.releaseSemaphore();
-
-			monitor.subTask(CooccurrenceCoreMessages.CooccurrencesEditor_32);
-			this.acquireSemaphore();
-			if (!this.stepGetScores())	{
-				return false;
-			}
-			monitor.worked(10);
-			this.releaseSemaphore();
-		}
-		// user canceling
-		catch(ThreadDeath e) {
-			return false;
-		}
-		catch(Exception e) {
-			e.printStackTrace();
-			return false;
-		}
-
-		return true;
-	}
-
-	/**
 	 * Count occ.
 	 *
 	 * @param propsvalue the propsvalue
@@ -557,15 +442,6 @@
 		}
 	}
 
-	/**
-	 * Gets the corpus.
-	 *
-	 * @return the corpus
-	 */
-	public Corpus getCorpus() {
-		return (Corpus) this.getParent();
-	}
-
 	//	/**
 	//	 * Compute.
 	//	 *
@@ -641,8 +517,18 @@
 	//		return true;
 	//	}
 
+	/**
+	 * Gets the corpus.
+	 *
+	 * @return the corpus
+	 */
+	public Corpus getCorpus() {
+		return (Corpus) this.getParent();
+	}
+
 	@Override
 	public String getDetails() {
+
 		StringBuffer buf = new StringBuffer(60);
 		buf.append("Cooc: \n"); //$NON-NLS-1$
 		buf.append(" Corpus: " + this.getParent() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -791,9 +677,9 @@
 		if (pMaxLeftContextSize > 0 && pMaxRightContextSize > 0)	{
 			output.append(" (" + (pMaxLeftContextSize-1) + ", " + (pMaxRightContextSize-1) + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
 		}
-		
+
 		if (output.length() == 0) output.append(getParent().getName()); // if the result was not computed
-		
+
 		return output.toString();
 	}
 
@@ -868,7 +754,7 @@
 			this.parent = corpus;
 			pQuery = conc.getQuery();
 			// System.out.println("CONC PROPS :"+conc.getViewProperties());
-			pProperties = conc.getViewProperties();
+			pProperties = conc.getKeywordViewProperties();
 			pStructuralUnitLimit = null;
 			pMaxLeftContextSize = conc.getLeftContextSize();
 			pMaxRightContextSize = conc.getRightContextSize();
@@ -948,7 +834,6 @@
 		this.pIncludeXpivot = includeXpivot;
 		this.buildLexicalTableWithCooccurrents = buildLexicalTableWithCooccurrents;
 
-		saveParameters();
 	}
 
 	@Override
@@ -960,7 +845,13 @@
 
 			StructuralUnit limit = corpus.getStructuralUnit(this.getStringParameterValue(CooccurrencePreferences.LIMIT));
 
-			List<Property> properties = (List<Property>)parameters.get(CooccurrencePreferences.PROPERTIES);
+			Object propsParam = parameters.get(CooccurrencePreferences.PROPERTIES);
+			List<Property> properties = null;
+			if (propsParam instanceof List)
+				properties = (List<Property>)propsParam;
+			else if (propsParam instanceof String) {
+				// parse String
+			}
 
 			int maxLeft = this.getIntParameterValue(CooccurrencePreferences.MAX_LEFT);
 			int minLeft = this.getIntParameterValue(CooccurrencePreferences.MIN_LEFT);
@@ -1542,17 +1433,6 @@
 		return true;
 	}
 
-	@Override
-	public boolean canCompute() {
-
-		boolean ret = pQuery != null && pProperties != null && getCorpus() != null && pQuery.getQueryString().length() > 0 && pProperties.size() > 0;
-
-		if (ret) {
-			this.saveParameters();
-		}
-		return ret;
-	}
-
 	/**
 	 * The Class CLine.
 	 */
Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 541)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 542)
@@ -9,6 +9,7 @@
 import java.util.Date;
 import java.util.UUID;
 import java.util.concurrent.Semaphore;
+import java.util.regex.Pattern;
 
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.osgi.framework.FrameworkUtil;
@@ -36,7 +37,10 @@
 	protected String uniqueID;
 	protected String path;
 	public static final DateFormat ID_TIME_FORMAT = new SimpleDateFormat("YYYYMMDD");
-
+	/** Editor can use this to test if the result need to be saved */
+	protected boolean hasBeenComputedOnce = false;
+	public boolean getHasBeenComputedOnce() { return hasBeenComputedOnce;}
+	
 	/**
 	 * The weight, essentially used for sorting purpose.
 	 */
@@ -78,7 +82,7 @@
 	private Semaphore progressSemaphore = new Semaphore(1);
 
 	/**
-	 * This variable ensure the TXMResult class constructor has been called
+	 * This variable ensure the TXMResult class constructor has been called. A lot of necessary things are done in the TXMREsult constructor.
 	 */
 	private boolean constructorCalled;
 
@@ -109,16 +113,6 @@
 	}
 
 	/**
-	 * Creates a new TXMResult, child of the specified parent.
-	 * 
-	 * @param parent
-	 * @param parameters
-	 */
-	public TXMResult(TXMResult parent, TXMParameters parameters) {
-
-	}
-
-	/**
 	 * Creates and stores an UUID dedicated to persistence for this result.
 	 */
 	protected void createUUID() {
@@ -363,7 +357,7 @@
 	}
 
 	/**
-	 * Removes the result from its parent.
+	 * Removes the result from its parent: call the parent's removeResult method.
 	 * 
 	 * @return
 	 */
@@ -377,7 +371,7 @@
 	}
 
 	/**
-	 * Gets all the children results.
+	 * Gets all the children results (nor a clone).
 	 * 
 	 * @return
 	 */
@@ -531,8 +525,8 @@
 	public abstract String getSimpleName();
 
 	/**
-	 * Gets some details about how the result has been computed (eg. additional
-	 * parameters, etc.). Shown in very large UI area
+	 * Gets some details about how the result has been computed  (eg. additional
+	 * parameters, etc.). Shown in large UI area
 	 * 
 	 * @return
 	 */
@@ -554,6 +548,7 @@
 		return this.uniqueID;
 	}
 
+	public static final Pattern filenamePattern = Pattern.compile("[^a-zA-Z0-9\\._-]+"); //$NON-NLS-1$
 	/**
 	 * Gets a string representing the result and that can be used as a file
 	 * name.
@@ -563,7 +558,7 @@
 	// FIXME: to discuss and/or to move in export layer
 	public String getValidFileName() {
 		try {
-			return this.getName().replaceAll("[^a-zA-Z0-9\\._-]+", "_");
+			return filenamePattern.matcher(this.getName()).replaceAll("_"); //$NON-NLS-1$
 		} catch (Exception e) {
 		}
 		return "";
@@ -693,12 +688,15 @@
 	 * 
 	 * @return
 	 */
-	public boolean compute(boolean update) throws Exception {
+	public final boolean compute(boolean update) throws Exception {
 		return this.compute(false, null);
 	}
 
 	/**
-	 * Computes the result.
+	 * Computes the result if 
+	 * it can be computed 
+	 * it is dirty 
+	 * the TXMResult constructor has been called
 	 * 
 	 * @param update
 	 *            TODO
@@ -718,7 +716,7 @@
 		// FIXME: Debug
 		System.err.println("TXMResult.compute(): computing result of type " + this.getClass() + "...");
 
-		if(!this.isDirty())	{
+		if (!this.isDirty()) {
 			
 			// FIXME: Debug
 			System.err.println("TXMResult.compute(): result is not dirty, computing skipped.");
@@ -726,7 +724,7 @@
 			return true;
 		}
 		
-		if(!hasBeenConstructorCalled())	{
+		if (!hasBeenConstructorCalled()) {
 			return false;
 		}
 
@@ -746,11 +744,11 @@
 		}
 
 		if (!saveParameters()) {
-			return false;
+			System.out.println("Warning: "+this.getName()+" parameters are not saved.");
 		}
 
 		this.dirty = false; // the _compute was successful the result is no more dirty
-
+		this.hasBeenComputedOnce = true; 
 		// FIXME: Debug
 		System.err.println("TXMResult.compute(): computing done.");
 
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 541)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 542)
@@ -155,27 +155,27 @@
 	/** The separator column. */
 	protected TableColumn separatorColumn;
 
-	/** The top line. */
-	protected int topLine;
-
-	/** The bottom line. */
-	protected int bottomLine;
-
-	/** The nblinesperpage. */
-	protected int nblinesperpage;
-
-	/** The nblinesmax. */
-	protected int nblinesmax;
-
-	/** The prop separator. */
-	protected String propSeparator = "_"; //$NON-NLS-1$
-
-//	/** The scroll composite. */
-//	private ScrolledComposite scrollComposite;
+//	/** The top line. */
+//	protected int topLine;
 //
-//	/** The head composite. */
-//	private Composite headComposite;
+//	/** The bottom line. */
+//	protected int bottomLine;
+//
+//	/** The nblinesperpage. */
+//	protected int nblinesperpage;
+//
+//	/** The nblinesmax. */
+//	protected int nblinesmax;
+//
+//	/** The prop separator. */
+//	protected String propSeparator = "_"; //$NON-NLS-1$
 
+	//	/** The scroll composite. */
+	//	private ScrolledComposite scrollComposite;
+	//
+	//	/** The head composite. */
+	//	private Composite headComposite;
+
 	/** The title. */
 	String title;
 
@@ -207,17 +207,6 @@
 	}
 
 	/**
-	 * Checks if is dirty.
-	 *
-	 * @return true, if is dirty
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return index.isDirty();
-	}
-
-	/**
 	 * Checks if is save as allowed.
 	 *
 	 * @return true, if is save as allowed
@@ -233,12 +222,7 @@
 		return false;
 	}
 
-	/**
-	 * Computes index.
-	 */
-	@Override
-	public void computeResult() {
-		StatusLine.setMessage(IndexUIMessages.IndexEditor_33);
+	public void setResultParameters() {
 		final Query query = new Query("");
 		if (!queryWidget.isDisposed() && !queryWidget.getQueryString().equals("\"\"")) { //$NON-NLS-1$
 			query.setQueryString(queryWidget.getQueryString());
@@ -249,66 +233,45 @@
 		final Integer Tmax = Integer.parseInt(this.VmaxSpinner.getText());
 		final Integer nLines = Integer.parseInt(this.NLignePPageSpinner.getText());
 		final List<Property> properties = propsArea.getProperties();
+		
+		index.setNLinesPerPage(NLignePPageSpinner.getSelection());
+		index.setVMax(VmaxSpinner.getSelection());
+		
+		index.setParameters(query, properties, Fmin, Fmax, Tmax, nLines);
+		index.setDirty();
+	}
+	
+	/**
+	 * Computes index.
+	 */
+	@Override
+	public void refresh(final boolean update) {
+		
 		//System.out.println("PROPERTIES: "+properties);
 		title = "Index...";
 		try {
-			JobHandler jobhandler = new JobHandler(title, go.getParent()) {
+			JobHandler jobhandler = new JobHandler(title) {
 				@Override
 				protected IStatus run(IProgressMonitor monitor) {
 					this.runInit(monitor);
 					try {
 						JobsTimer.start();
 
-						index.setParameters(query, properties, Fmin, Fmax, Tmax, nLines);
-
-						if (index.canCompute() && index.isDirty()) {
-
-							title = NLS.bind(IndexUIMessages.IndexEditor_2, new Object[]{
-									query.getQueryString(), properties, index.getCorpus().getName()});
-							if (index.getPartition() != null)
-								title = NLS.bind(IndexUIMessages.IndexEditor_20, new Object[]{
-										query.getQueryString(), properties, index.getCorpus().getName()});
-
-							System.out.println(title);
-							Log.info("Start computing Index...");
-
-							index.compute(false, this);
-						} else {
-							return Status.CANCEL_STATUS;
-						}
-
 						if (monitor.isCanceled())
 							return Status.CANCEL_STATUS;
 
-						final String message;
-						if (index.getV() == 1)
-							message = (RCPMessages.ONE_RESULT);
-						else if (index.getV() > 0)
-							message = (RCPMessages.bind(RCPMessages.CreatePartition_55, index.getV(), index.getT()));
-						else
-							message = (TXMCoreMessages.COMPUTE_DONE_NO_RESULT);
-
-						if (monitor.isCanceled())
-							return Status.CANCEL_STATUS;
-
 						monitor.worked(95);
 						// refresh ui
 						syncExec(new Runnable() {
 							@Override
 							public void run() {
 
-								System.out.println(message);
-								StatusLine.setMessage(message);
-
-								refresh();
-
 								QueriesView.refresh();
 								RVariablesView.refresh();
 
 								if (!queryWidget.isDisposed()) queryWidget.memorize();
-								nblinesperpage = NLignePPageSpinner.getSelection();
-								nblinesmax = VmaxSpinner.getSelection();
-								fillDisplayArea(0, NLignePPageSpinner.getSelection());
+								
+								fillDisplayArea();
 
 								viewer.getTable().setFocus();
 							}
@@ -325,7 +288,7 @@
 							System.out.println(IndexUIMessages.IndexEditor_10+e1);
 							org.txm.rcp.utils.Logger.printStackTrace(e1);
 						}
-						Log.severe("Error while computing Index with "+query+" query: "+e.getLocalizedMessage());
+						Log.severe("Error while computing Index: "+e.getLocalizedMessage());
 					} finally {
 						monitor.done();
 						JobsTimer.stopAndPrint();
@@ -340,33 +303,7 @@
 		}
 	}
 
-
-
 	/**
-	 * Simple query.
-	 *
-	 * @param query the query
-	 * @param props the props
-	 * @return true, if successful
-	 */
-	private boolean simpleQuery(Query query, List<Property> props) {
-		for(Property p : props) {
-			if(p instanceof StructuralUnitProperty) return false;
-		}
-		String trimed = query.getQueryString().trim();
-		Property p = props.get(0);
-		if (props.size() > 1)
-			return false;
-		else if (trimed.equals("[]")) //$NON-NLS-1$
-			return true;
-		else if (trimed.equals("[" + p.getName() + "=\".*\"]")) //$NON-NLS-1$ //$NON-NLS-2$
-		{
-			return true;
-		} 
-		return false;
-	}
-
-	/**
 	 * Creates the part control.
 	 *
 	 * @param parent the parent
@@ -375,10 +312,10 @@
 	@Override
 	public void createPartControl(Composite parent) {
 		super.createPartControl(parent);
-		
+
 		Composite paramArea = this.getCommandParametersGroup();
 		paramArea.setLayout(new FormLayout());
-		
+
 		// info&navigation panel
 		final Composite infosArea = this.topToolBar.installGroup("Infos", "Informations and Navigation", null, true);
 
@@ -414,7 +351,8 @@
 			@Override
 			public void keyPressed(KeyEvent e) {
 				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					computeResult();
+					setResultParameters();
+					compute(true);
 				}
 			}
 			@Override
@@ -431,8 +369,8 @@
 			@Override
 			public void handleEvent(Event event) {
 				if (!initializing && TXMPreferences.getBoolean(RCPPreferences.AUTO_UPDATE_EDITOR, RCPPreferences.PREFERENCES_NODE)) {
-					index.setDirty();
-					computeResult();
+					setResultParameters();
+					compute(false);
 				}
 			}
 		});
@@ -455,7 +393,8 @@
 		SelectionListener listener2 = new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				computeResult();
+				setResultParameters();
+				compute(true);
 			}
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) { }
@@ -535,7 +474,9 @@
 
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
-				fillDisplayArea(0, NLignePPageSpinner.getSelection());
+				index.setTopLine(0);
+				index.setNLinesPerPage(NLignePPageSpinner.getSelection());
+				fillDisplayArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -555,7 +496,9 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				fillDisplayArea(0, NLignePPageSpinner.getSelection());
+				index.setTopLine(0);
+				index.setNLinesPerPage(NLignePPageSpinner.getSelection());
+				fillDisplayArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -568,10 +511,11 @@
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				int i = (index.getV()/NLignePPageSpinner.getSelection());
-				int top = top = i*NLignePPageSpinner.getSelection();
-
-				int bottom = top + NLignePPageSpinner.getSelection();
-				fillDisplayArea(top, bottom);
+				int top = i*NLignePPageSpinner.getSelection();
+				
+				index.setTopLine(top);
+				fillDisplayArea();
+				
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -583,9 +527,8 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				int top = topLine + NLignePPageSpinner.getSelection();
-				int bottom = top + NLignePPageSpinner.getSelection();
-				fillDisplayArea(top,bottom);
+				index.setTopLine(index.getTopIndex() + index.getNLinesPerPage());
+				fillDisplayArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -597,11 +540,10 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				int top = topLine - NLignePPageSpinner.getSelection();
-				if (top < 0)
-					top = 0;
-				int bottom = top + NLignePPageSpinner.getSelection();
-				fillDisplayArea(top, bottom);
+				int top = index.getTopIndex() - index.getNLinesPerPage();
+				if (top < 0) { top = 0; }
+				index.setTopLine(top);
+				fillDisplayArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -654,25 +596,25 @@
 		viewer.setContentProvider(new LineContentProvider());
 		viewer.setInput(new ArrayList<Property>());
 
-//TODO replace this with command+menucontribution		
-//		viewer.getTable().addMouseListener(new MouseAdapter() {
-//			@Override
-//			public void mouseDoubleClick(MouseEvent e) {
-//				Point mouseposition = new Point(e.x
-//						+ viewer.getTable().getHorizontalBar()
-//						.getSelection(), e.y);
-//				int col = getPointedColumn(mouseposition);
-//				if (col == 1) {
-//					IndexToConcordance.link(IndexEditor.this,
-//							(IStructuredSelection) viewer
-//							.getSelection());
-//				} else if (col == 2) {
-//					IndexToProgression.link(IndexEditor.this,
-//							(IStructuredSelection) viewer
-//							.getSelection());
-//				}
-//			}
-//		});
+		//TODO replace this with command+menucontribution		
+		//		viewer.getTable().addMouseListener(new MouseAdapter() {
+		//			@Override
+		//			public void mouseDoubleClick(MouseEvent e) {
+		//				Point mouseposition = new Point(e.x
+		//						+ viewer.getTable().getHorizontalBar()
+		//						.getSelection(), e.y);
+		//				int col = getPointedColumn(mouseposition);
+		//				if (col == 1) {
+		//					IndexToConcordance.link(IndexEditor.this,
+		//							(IStructuredSelection) viewer
+		//							.getSelection());
+		//				} else if (col == 2) {
+		//					IndexToProgression.link(IndexEditor.this,
+		//							(IStructuredSelection) viewer
+		//							.getSelection());
+		//				}
+		//			}
+		//		});
 
 		nColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
 		nColumn.setText(" "); //$NON-NLS-1$
@@ -701,7 +643,7 @@
 				}
 
 				StatusLine.setMessage(RCPMessages.SORT_DONE);
-				fillDisplayArea(topLine, bottomLine);
+				fillDisplayArea();
 			}
 
 			@Override
@@ -738,7 +680,7 @@
 					}
 				}
 				StatusLine.setMessage(RCPMessages.SORT_DONE);
-				fillDisplayArea(topLine, bottomLine);
+				fillDisplayArea();
 			}
 
 			@Override
@@ -774,7 +716,7 @@
 		viewer.getTable().pack();
 		parent.layout(true);
 
-		computeResult();
+		//compute(true);
 	}
 
 	/**
@@ -884,10 +826,13 @@
 	 * @param from the from
 	 * @param to the to
 	 */
-	public void fillDisplayArea(int from, int to) {
+	public void fillDisplayArea() {
 		// System.out.println("call fill from "+from+" to "+to);
-		from = Math.max(from, 0);
+		int from = index.getTopIndex();
+		
+		int to = from + index.getNLinesPerPage();
 		to = Math.min(to, index.getV());
+		
 		List<Line> lines = null;
 		if (index.getV() > 0) {
 			lines = index.getLines(from, to);
@@ -910,7 +855,7 @@
 
 		String unitColumnHeader = ""; //$NON-NLS-1$
 		for (Property p : index.getProperties())
-			unitColumnHeader += p.getName() + propSeparator;
+			unitColumnHeader += p.getName() + index.getPropertySeparator();
 		if (unitColumnHeader.length() > 0)
 			unitColumnHeader = unitColumnHeader.substring(0, unitColumnHeader
 					.length() - 1);
@@ -918,9 +863,6 @@
 
 		viewer.setInput(lines);
 		viewer.refresh();
-		// System.out.println("table refreshed from "+from+" to "+to+" with : "+lines);
-		topLine = from;
-		bottomLine = to;
 
 		// Refresh and pack the columns
 		viewer.getControl().setRedraw(false);
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 541)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 542)
@@ -374,8 +374,8 @@
 			
 			
 			// Loads new lines, fill the display area and select the table row
-			if(loadLines)	{
-				linkedEditor.fillDisplayArea(top, bottom);
+			if (loadLines)	{
+				linkedEditor.fillDisplayArea();
 			}
 
 			// update range change tracking variables
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/ViewPropertySelection.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/ViewPropertySelection.java	(revision 541)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/ViewPropertySelection.java	(revision 542)
@@ -136,6 +136,6 @@
 			break;
 		}
 		
-		concordanceEditor.resetRightTableColumnWidths();
+		//concordanceEditor.resetRightTableColumnWidths();
 	}
 }
